/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "./src/edit.js":
/*!*********************!*\
  !*** ./src/edit.js ***!
  \*********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @wordpress/element */ "@wordpress/element");
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _wordpress_i18n__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @wordpress/i18n */ "@wordpress/i18n");
/* harmony import */ var _wordpress_i18n__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_wordpress_i18n__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _wordpress_block_editor__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @wordpress/block-editor */ "@wordpress/block-editor");
/* harmony import */ var _wordpress_block_editor__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_wordpress_block_editor__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _wordpress_api_fetch__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @wordpress/api-fetch */ "@wordpress/api-fetch");
/* harmony import */ var _wordpress_api_fetch__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_wordpress_api_fetch__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _wordpress_data__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @wordpress/data */ "@wordpress/data");
/* harmony import */ var _wordpress_data__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_wordpress_data__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @wordpress/components */ "@wordpress/components");
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var _wordpress_blocks__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @wordpress/blocks */ "@wordpress/blocks");
/* harmony import */ var _wordpress_blocks__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(_wordpress_blocks__WEBPACK_IMPORTED_MODULE_6__);
/* harmony import */ var _editor_scss__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./editor.scss */ "./src/editor.scss");
/* harmony import */ var _rules_js__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./rules.js */ "./src/rules.js");










/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (({
  attributes,
  setAttributes
}) => {
  const path = 'dmg-ai-tools/ask';
  const language = AIToolsOptions?.language ? AIToolsOptions.language : "British English";
  const allowedFormats = [];
  const [disabled, setDisabled] = (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
  const [isRewriting, setIsRewriting] = (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
  const [success, setSuccess] = (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.useState)(false);

  // Perform the request
  const sendRequest = () => {
    setDisabled(true);
    setIsRewriting(true);
    setSuccess(false);
    setAttributes({
      rewritten: ''
    });
    let system_message = attributes?.system_message ? attributes.system_message : AIToolsOptions?.system_message;
    if (attributes.response_length) system_message += `\n- Respond with a body content with a target length ${attributes.response_length} words`;
    system_message += `\n- Use ${language}`;
    let user_prompt = attributes?.rewrite_prompt ? attributes.rewrite_prompt : AIToolsOptions?.rewrite_prompt;
    user_prompt += ` using a ${attributes.tone} tone`;
    if (attributes.content) user_prompt += `\n\n${attributes.content}`;
    let data = {
      "messages": [{
        "role": "system",
        "content": system_message
      }, {
        "role": "user",
        "content": user_prompt
      }],
      "temperature": attributes.temperature,
      "top_p": attributes.top_p,
      "frequency_penalty": attributes.frequency_penalty,
      "presence_penalty": attributes.presence_penalty,
      "max_tokens": attributes.max_tokens,
      "stop": null
    };
    performApiRequest(data).then(response_message => {
      let p_words_length = attributes?.p_words_length ? attributes.p_words_length : AIToolsOptions?.p_words_length;
      const jsonPattern = {
        "content": [`paragraph 1 (max ${p_words_length} words)`, `paragraph 2 (max ${p_words_length} words)`, `paragraph 3 (max ${p_words_length} words)`, `... (max ${p_words_length} words)`]
      };
      system_message += `\n- Use ${language}`;
      system_message += `\n- Use a ${attributes.tone} tone`;
      system_message += `\n- Respond in only one single JSON in this format: \n\n ${JSON.stringify(jsonPattern)}`;
      system_message += `\n- Every JSON element must have less than ${p_words_length} words`;
      user_prompt = attributes?.rewrite_prompt ? attributes.rewrite_prompt : AIToolsOptions?.rewrite_prompt;
      if (attributes.content) user_prompt += `\n\n${response_message}`;
      let data = {
        "messages": [{
          "role": "system",
          "content": system_message
        }, {
          "role": "user",
          "content": user_prompt
        }],
        "temperature": attributes.temperature,
        "top_p": attributes.top_p,
        "frequency_penalty": attributes.frequency_penalty,
        "presence_penalty": attributes.presence_penalty,
        "max_tokens": attributes.max_tokens,
        "stop": null
      };
      performApiRequest(data).then(response_message => {
        setDisabled(false);
        setIsRewriting(false);
        setSuccess(true);
        const json = JSON.parse(response_message);
        const paragraphs = [];
        let rewritten_html = '';
        if (json.content) {
          json.content.forEach(paragraph => {
            rewritten_html += `<p>${paragraph}</p>`;
            paragraphs.push(paragraph);
          });
        }
        setAttributes({
          paragraphs: paragraphs
        });
        setAttributes({
          rewritten: rewritten_html
        });
      });
    });
  };

  // Perform the Open AI API request
  const performApiRequest = async data => {
    return _wordpress_api_fetch__WEBPACK_IMPORTED_MODULE_3___default()({
      path: path,
      method: 'POST',
      data: data
    }).then(response => {
      let response_message = response?.choices[0]?.message?.content;
      if (response_message.includes('__DMG_AI_ERROR__')) {
        setDisabled(false);
        setIsRewriting(false);
        setSuccess(false);
        setAttributes({
          rewritten: "I'm unable to generate new content or provide additional information. Please provide the content you'd like me to rephrase."
        });
      } else {
        return response_message;
      }
    }).catch(error => {
      setDisabled(false);
      setIsRewriting(false);
      setSuccess(false);
      if (error?.error?.message) {
        setAttributes({
          rewritten: error.error.message
        });
      } else {
        setAttributes({
          rewritten: 'A generic error occurred. Please try again'
        });
      }
    });
    ;
  };

  // Handle the transformation of the responce into gutenberg blocks
  const acceptTransformation = () => {
    let selectedBlock = (0,_wordpress_data__WEBPACK_IMPORTED_MODULE_4__.select)('core/block-editor').getSelectedBlock();
    let blocks = (0,_wordpress_data__WEBPACK_IMPORTED_MODULE_4__.select)('core/block-editor').getBlocks();
    let blockIndex = blocks.findIndex(block => block.clientId === selectedBlock?.clientId);
    let newBlocks = [];
    if (blockIndex !== -1) {
      attributes?.paragraphs.forEach(paragraph => {
        newBlocks.push((0,_wordpress_blocks__WEBPACK_IMPORTED_MODULE_6__.createBlock)('core/paragraph', {
          content: paragraph
        }));
      });
      (0,_wordpress_data__WEBPACK_IMPORTED_MODULE_4__.dispatch)('core/block-editor').insertBlocks(newBlocks, blockIndex);
      (0,_wordpress_data__WEBPACK_IMPORTED_MODULE_4__.dispatch)('core/block-editor').removeBlocks([selectedBlock?.clientId]);

      // Keep track of the AI rewrite assigning a specific term
      let terms = (0,_wordpress_data__WEBPACK_IMPORTED_MODULE_4__.select)('core/editor').getEditedPostAttribute(AIToolsOptions?.ai_powered_taxonomy_name);
      terms.push(Number(AIToolsOptions?.ai_powered_term_id));
      (0,_wordpress_data__WEBPACK_IMPORTED_MODULE_4__.dispatch)('core/editor').editPost({
        [AIToolsOptions.ai_powered_taxonomy_name]: terms
      });
    }
  };
  return (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.Fragment, null, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_block_editor__WEBPACK_IMPORTED_MODULE_2__.InspectorControls, null, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    class: "ai-tools"
  }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.PanelBody, {
    title: "Settings",
    initialOpen: true
  }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.PanelRow, null, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.SelectControl, {
    label: "Tone",
    value: attributes.tone || (attributes.tone = 'informal'),
    options: [{
      value: 'formal',
      label: 'Formal'
    }, {
      value: 'informal',
      label: 'Informal'
    }, {
      value: 'optimistic',
      label: 'Optimistic'
    }, {
      value: 'humorous',
      label: 'Humorous'
    }, {
      value: 'serious',
      label: 'Serious'
    }, {
      value: 'skeptical',
      label: 'Skeptical'
    }, {
      value: 'empathetic',
      label: 'Empathetic'
    }, {
      value: 'confident',
      label: 'Confident'
    }, {
      value: 'passionate',
      label: 'Passionate'
    }, {
      value: 'provocative',
      label: 'Provocative'
    }],
    onChange: newValue => setAttributes({
      tone: newValue
    })
  }), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.Tooltip, {
    text: "Define the tone for the rewriting",
    position: "right"
  }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    class: "tooltip dashicon dashicons dashicons-info-outline"
  }))), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.PanelRow, null, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.__experimentalNumberControl, {
    isShiftStepEnabled: true,
    label: "Words Length",
    min: "0",
    value: attributes.response_length,
    onChange: value => setAttributes({
      response_length: Number(value)
    })
  }), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.Tooltip, {
    text: "Define the length of the rewritten content",
    position: "right"
  }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    class: "tooltip dashicon dashicons dashicons-info-outline"
  }))), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.PanelRow, null, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.__experimentalNumberControl, {
    isShiftStepEnabled: true,
    label: "P Words Length",
    min: "0",
    value: attributes.p_words_length || (attributes.p_words_length = AIToolsOptions?.p_words_length),
    onChange: value => setAttributes({
      p_words_length: Number(value)
    })
  }), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.Tooltip, {
    text: "Define how many words per paragraph",
    position: "right"
  }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    class: "tooltip dashicon dashicons dashicons-info-outline"
  })))), AIToolsOptions?.is_advanced && (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.PanelBody, {
    title: "Advanced Settings",
    initialOpen: true
  }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.PanelRow, null, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.TextareaControl, {
    label: "User message",
    value: attributes.rewrite_prompt || (attributes.rewrite_prompt = AIToolsOptions?.rewrite_prompt),
    onChange: value => setAttributes({
      rewrite_prompt: value
    })
  }), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.Tooltip, {
    text: "The user message represents the actual input or message from the user. It provides context and instructions.",
    position: "right"
  }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    class: "tooltip dashicon dashicons dashicons-info-outline"
  }))), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.PanelRow, null, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.TextareaControl, {
    label: "System message",
    value: attributes.system_message || (attributes.system_message = AIToolsOptions?.system_message),
    onChange: value => setAttributes({
      system_message: value
    })
  }), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.Tooltip, {
    text: "Give the model instructions about how it should behave and any context it should reference when generating a response. You can tell the assistant what it should and shouldn\u2019t answer, and tell it how to format responses.",
    position: "right"
  }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    class: "tooltip dashicon dashicons dashicons-info-outline"
  }))), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.PanelRow, null, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.__experimentalNumberControl, {
    isShiftStepEnabled: true,
    step: "0.01",
    label: "temperature",
    max: "1",
    min: "0",
    value: attributes.temperature || (attributes.temperature = Number(AIToolsOptions?.temperature)),
    onChange: value => setAttributes({
      temperature: Number(value)
    })
  }), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.Tooltip, {
    text: "Controls randomness. Lowering the temperature means that the model will produce more repetitive and deterministic responses. Try adjusting temperature or Top P but not both.",
    position: "right"
  }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    class: "tooltip dashicon dashicons dashicons-info-outline"
  }))), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.PanelRow, null, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.__experimentalNumberControl, {
    isShiftStepEnabled: true,
    step: "0.01",
    label: "Top P",
    max: "1",
    min: "0",
    value: attributes.top_p || (attributes.top_p = Number(AIToolsOptions?.top_p)),
    onChange: value => setAttributes({
      top_p: Number(value)
    })
  }), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.Tooltip, {
    text: "Similar to temperature, this controls randomness but uses a different method. Lowering Top P will narrow the model\u2019s token selection to likelier tokens. Try adjusting temperature or Top P but not both.",
    position: "right"
  }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    class: "tooltip dashicon dashicons dashicons-info-outline"
  }))), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.PanelRow, null, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.__experimentalNumberControl, {
    isShiftStepEnabled: true,
    step: "0.01",
    label: "Frequency penalty",
    max: "2",
    min: "0",
    value: attributes.frequency_penalty || (attributes.frequency_penalty = Number(AIToolsOptions?.frequency_penalty)),
    onChange: value => setAttributes({
      frequency_penalty: Number(value)
    })
  }), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.Tooltip, {
    text: "Reduce the chance of repeating a token proportionally based on how often it has appeared in the text so far. This decreases the likelihood of repeating the exact same text in a response.",
    position: "right"
  }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    class: "tooltip dashicon dashicons dashicons-info-outline"
  }))), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.PanelRow, null, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.__experimentalNumberControl, {
    isShiftStepEnabled: true,
    step: "0.01",
    label: "Presence penalty",
    max: "2",
    min: "0",
    value: attributes.presence_penalty || (attributes.presence_penalty = Number(AIToolsOptions?.presence_penalty)),
    onChange: value => setAttributes({
      presence_penalty: Number(value)
    })
  }), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.Tooltip, {
    text: "Reduce the chance of repeating any token that has appeared in the text at all so far. This increases the likelihood of introducing new topics in a response.",
    position: "right"
  }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    class: "tooltip dashicon dashicons dashicons-info-outline"
  }))), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.PanelRow, null, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.__experimentalNumberControl, {
    isShiftStepEnabled: true,
    label: "Max Tokens",
    min: "0",
    value: attributes.max_tokens || (attributes.max_tokens = Number(AIToolsOptions?.max_tokens)),
    onChange: value => setAttributes({
      max_tokens: Number(value)
    })
  }), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.Tooltip, {
    text: "Set a limit on the number of tokens per model response. One token is roughly 4 characters for typical English text.",
    position: "right"
  }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    class: "tooltip dashicon dashicons dashicons-info-outline"
  })))))), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", (0,_wordpress_block_editor__WEBPACK_IMPORTED_MODULE_2__.useBlockProps)(), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_block_editor__WEBPACK_IMPORTED_MODULE_2__.RichText, {
    placeholder: (0,_wordpress_i18n__WEBPACK_IMPORTED_MODULE_1__.__)("Rewrite this...", "dmg"),
    value: attributes.content,
    allowedFormats: allowedFormats,
    onChange: newValue => {
      let newContent = newValue.replace(/<[^>]*>?/gm, '');
      setAttributes({
        content: newContent
      });
      setAttributes({
        response_length: newContent.split(" ").length
      });
    }
  }), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.Button, {
    variant: "secondary",
    disabled: disabled,
    onClick: sendRequest
  }, isRewriting ? 'REWRITING...' : 'REWRITE'), attributes.rewritten && (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", null, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.RawHTML)({
    children: attributes.rewritten
  })), success && !isRewriting && (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.Button, {
    variant: "secondary",
    onClick: acceptTransformation
  }, "ACCEPT")), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_block_editor__WEBPACK_IMPORTED_MODULE_2__.BlockControls, null, attributes.rewritten && !isRewriting && (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.ToolbarButton, {
    disabled: disabled,
    icon: 'update',
    label: "Try again",
    onClick: sendRequest
  }, "Try again"), success && (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.ToolbarButton, {
    icon: 'saved',
    label: "Accept",
    onClick: acceptTransformation
  }, "Accept")), isRewriting && (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_block_editor__WEBPACK_IMPORTED_MODULE_2__.BlockControls, null, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.ToolbarButton, {
    disabled: disabled,
    label: "Rewriting..."
  }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_5__.Spinner, null), " Rewriting...")));
});

/***/ }),

/***/ "./src/rules.js":
/*!**********************!*\
  !*** ./src/rules.js ***!
  \**********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @wordpress/element */ "@wordpress/element");
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _wordpress_data__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @wordpress/data */ "@wordpress/data");
/* harmony import */ var _wordpress_data__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_wordpress_data__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _wordpress_compose__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @wordpress/compose */ "@wordpress/compose");
/* harmony import */ var _wordpress_compose__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_wordpress_compose__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _wordpress_plugins__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @wordpress/plugins */ "@wordpress/plugins");
/* harmony import */ var _wordpress_plugins__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_wordpress_plugins__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _wordpress_edit_post__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @wordpress/edit-post */ "@wordpress/edit-post");
/* harmony import */ var _wordpress_edit_post__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_wordpress_edit_post__WEBPACK_IMPORTED_MODULE_4__);






// Prevent publish/update post if the dmg/ai-tools is present in the content
const postSaveRules = ({
  blocks
}) => {
  const lockName = 'dmgAILock';
  const message = "Please complete the AI rewriting in order to save the post.";
  if (blocks.some(block => {
    return block.name === 'dmg/ai-tools';
  })) {
    (0,_wordpress_data__WEBPACK_IMPORTED_MODULE_1__.dispatch)('core/editor').lockPostSaving(lockName);
    return (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_edit_post__WEBPACK_IMPORTED_MODULE_4__.PluginPrePublishPanel, {
      title: "dmg ai tools",
      initialOpen: true
    }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
      class: "components-notice is-error"
    }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
      class: "components-notice__content"
    }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("p", null, message))));
  } else {
    (0,_wordpress_data__WEBPACK_IMPORTED_MODULE_1__.dispatch)('core/editor').unlockPostSaving(lockName);
    return null;
  }
};
const dmgAiToolsRules = (0,_wordpress_compose__WEBPACK_IMPORTED_MODULE_2__.compose)((0,_wordpress_data__WEBPACK_IMPORTED_MODULE_1__.withSelect)(select => ({
  blocks: select('core/block-editor').getBlocks()
})))(postSaveRules);
(0,_wordpress_plugins__WEBPACK_IMPORTED_MODULE_3__.registerPlugin)('dmg-ai-tools-rules', {
  render: dmgAiToolsRules
});

/***/ }),

/***/ "./src/editor.scss":
/*!*************************!*\
  !*** ./src/editor.scss ***!
  \*************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
// extracted by mini-css-extract-plugin


/***/ }),

/***/ "@wordpress/api-fetch":
/*!**********************************!*\
  !*** external ["wp","apiFetch"] ***!
  \**********************************/
/***/ ((module) => {

module.exports = window["wp"]["apiFetch"];

/***/ }),

/***/ "@wordpress/block-editor":
/*!*************************************!*\
  !*** external ["wp","blockEditor"] ***!
  \*************************************/
/***/ ((module) => {

module.exports = window["wp"]["blockEditor"];

/***/ }),

/***/ "@wordpress/blocks":
/*!********************************!*\
  !*** external ["wp","blocks"] ***!
  \********************************/
/***/ ((module) => {

module.exports = window["wp"]["blocks"];

/***/ }),

/***/ "@wordpress/components":
/*!************************************!*\
  !*** external ["wp","components"] ***!
  \************************************/
/***/ ((module) => {

module.exports = window["wp"]["components"];

/***/ }),

/***/ "@wordpress/compose":
/*!*********************************!*\
  !*** external ["wp","compose"] ***!
  \*********************************/
/***/ ((module) => {

module.exports = window["wp"]["compose"];

/***/ }),

/***/ "@wordpress/data":
/*!******************************!*\
  !*** external ["wp","data"] ***!
  \******************************/
/***/ ((module) => {

module.exports = window["wp"]["data"];

/***/ }),

/***/ "@wordpress/edit-post":
/*!**********************************!*\
  !*** external ["wp","editPost"] ***!
  \**********************************/
/***/ ((module) => {

module.exports = window["wp"]["editPost"];

/***/ }),

/***/ "@wordpress/element":
/*!*********************************!*\
  !*** external ["wp","element"] ***!
  \*********************************/
/***/ ((module) => {

module.exports = window["wp"]["element"];

/***/ }),

/***/ "@wordpress/i18n":
/*!******************************!*\
  !*** external ["wp","i18n"] ***!
  \******************************/
/***/ ((module) => {

module.exports = window["wp"]["i18n"];

/***/ }),

/***/ "@wordpress/plugins":
/*!*********************************!*\
  !*** external ["wp","plugins"] ***!
  \*********************************/
/***/ ((module) => {

module.exports = window["wp"]["plugins"];

/***/ }),

/***/ "./src/block.json":
/*!************************!*\
  !*** ./src/block.json ***!
  \************************/
/***/ ((module) => {

module.exports = JSON.parse('{"$schema":"https://schemas.wp.org/trunk/block.json","apiVersion":3,"name":"dmg/ai-tools","version":"0.1.0","title":"DMG AI Rewrite","category":"widgets","icon":"embed-generic","description":"","supports":{"html":false},"attributes":{"content":{"type":"string"},"tone":{"type":"string"},"rewrite_prompt":{"type":"string"},"system_message":{"type":"string"},"language":{"type":"string"},"response_length":{"type":"number"},"temperature":{"type":"number"},"top_p":{"type":"number"},"frequency_penalty":{"type":"number"},"presence_penalty":{"type":"number"},"max_tokens":{"type":"number"}},"textdomain":"dmg-ai-tools","editorScript":"file:./index.js","editorStyle":"file:./index.css"}');

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	(() => {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = (module) => {
/******/ 			var getter = module && module.__esModule ?
/******/ 				() => (module['default']) :
/******/ 				() => (module);
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
(() => {
/*!**********************!*\
  !*** ./src/index.js ***!
  \**********************/
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @wordpress/element */ "@wordpress/element");
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _wordpress_blocks__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @wordpress/blocks */ "@wordpress/blocks");
/* harmony import */ var _wordpress_blocks__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_wordpress_blocks__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _edit__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./edit */ "./src/edit.js");
/* harmony import */ var _block_json__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./block.json */ "./src/block.json");



/**
 * Internal dependencies
 */


(0,_wordpress_blocks__WEBPACK_IMPORTED_MODULE_1__.registerBlockType)(_block_json__WEBPACK_IMPORTED_MODULE_3__.name, {
  edit: _edit__WEBPACK_IMPORTED_MODULE_2__["default"],
  save: () => (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.Fragment, null)
});
})();

/******/ })()
;
//# sourceMappingURL=index.js.map