<?php
/**
 * Plugin Name: DMG AI Tools
 * Plugin URI:  https://github.com/ANMedia/dmg-ai-tools
 * Description: AI Tools for DMG Media
 * Version:     0.1.0
 * Author:      Metro.co.uk
 * Author URI:  https://github.com/ANMedia/dmg-ai-tools/graphs/contributors
 * Text Domain: dmg-ai-tools
 */

namespace DMG\AI_Tools;

if ( ! class_exists( 'DMG\AI_Tools\Init' ) ) :

	/**
	 * Class Init
	 */
	class Init {

		/**
		 * The capability name
		 *
		 * @var string
		 */
		const CAPABILITY = 'dmg_ai_tools';

		/**
		 * The advanced users capability name
		 *
		 * @var string
		 */
		const ADVANCED_CAPABILITY = 'dmg_ai_tools_advanced';

		/**
		 * Init constructor.
		 */
		function __construct() {
			add_action( 'admin_init', [ __CLASS__, 'add_capability' ] );

			require_once plugin_dir_path( __FILE__ ) . 'class-settings.php';
			require_once plugin_dir_path( __FILE__ ) . 'class-rest-api.php';
			require_once plugin_dir_path( __FILE__ ) . 'class-assistant.php';
		}

		/**
		 * Add the capability for administrators
		 */
		public static function add_capability() {
			$role_object = get_role( 'administrator' );
			$role_object->add_cap( self::CAPABILITY );
			$role_object->add_cap( self::ADVANCED_CAPABILITY  );
		}

	}

	new Init();

endif;

